<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVersionAreaDesign ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVersionAreaDesign
 * @subpackage Arrays
 */
class ArrayOfVersionAreaDesign extends AbstractStructArrayBase
{
    /**
     * The VersionAreaDesign
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\VersionAreaDesign[]
     */
    public $VersionAreaDesign;
    /**
     * Constructor method for ArrayOfVersionAreaDesign
     * @uses ArrayOfVersionAreaDesign::setVersionAreaDesign()
     * @param \patest\StructType\VersionAreaDesign[] $versionAreaDesign
     */
    public function __construct(array $versionAreaDesign = array())
    {
        $this
            ->setVersionAreaDesign($versionAreaDesign);
    }
    /**
     * Get VersionAreaDesign value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\VersionAreaDesign[]|null
     */
    public function getVersionAreaDesign()
    {
        return isset($this->VersionAreaDesign) ? $this->VersionAreaDesign : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVersionAreaDesign method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVersionAreaDesign method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVersionAreaDesignForArrayConstraintsFromSetVersionAreaDesign(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVersionAreaDesignVersionAreaDesignItem) {
            // validation for constraint: itemType
            if (!$arrayOfVersionAreaDesignVersionAreaDesignItem instanceof \patest\StructType\VersionAreaDesign) {
                $invalidValues[] = is_object($arrayOfVersionAreaDesignVersionAreaDesignItem) ? get_class($arrayOfVersionAreaDesignVersionAreaDesignItem) : sprintf('%s(%s)', gettype($arrayOfVersionAreaDesignVersionAreaDesignItem), var_export($arrayOfVersionAreaDesignVersionAreaDesignItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VersionAreaDesign property can only contain items of type \patest\StructType\VersionAreaDesign, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VersionAreaDesign value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\VersionAreaDesign[] $versionAreaDesign
     * @return \patest\ArrayType\ArrayOfVersionAreaDesign
     */
    public function setVersionAreaDesign(array $versionAreaDesign = array())
    {
        // validation for constraint: array
        if ('' !== ($versionAreaDesignArrayErrorMessage = self::validateVersionAreaDesignForArrayConstraintsFromSetVersionAreaDesign($versionAreaDesign))) {
            throw new \InvalidArgumentException($versionAreaDesignArrayErrorMessage, __LINE__);
        }
        if (is_null($versionAreaDesign) || (is_array($versionAreaDesign) && empty($versionAreaDesign))) {
            unset($this->VersionAreaDesign);
        } else {
            $this->VersionAreaDesign = $versionAreaDesign;
        }
        return $this;
    }
    /**
     * Add item to VersionAreaDesign value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\VersionAreaDesign $item
     * @return \patest\ArrayType\ArrayOfVersionAreaDesign
     */
    public function addToVersionAreaDesign(\patest\StructType\VersionAreaDesign $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\VersionAreaDesign) {
            throw new \InvalidArgumentException(sprintf('The VersionAreaDesign property can only contain items of type \patest\StructType\VersionAreaDesign, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VersionAreaDesign[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\VersionAreaDesign|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\VersionAreaDesign|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\VersionAreaDesign|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\VersionAreaDesign|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\VersionAreaDesign|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VersionAreaDesign
     */
    public function getAttributeName()
    {
        return 'VersionAreaDesign';
    }
}
